* it.prg
* top level program 

*
* set stuff up
*
* talk is a special case
if set("talk") == "ON"
 set talk off
 m.gcOldTalk = "ON"
else
 m.gcOldTalk = "OFF"
endif

* clean out everything
release all except g*
close all
clear menu
clear popup
clear window
clear

* set up outside resources
set classlib to BASEAPP.VCX
oEnv = createobject("ENV")
* (stubbed out for this example)
*\\\ set help to ("MYHELP")
set procedure to ("MYPROC")
*\\\ set resource to ("MYRES")

* save current environment
oEnv.SaveSets()

* initialize various system attributes
* by reading in from outside the application 
* (either an INI file or the Windows Registry)
* (GetRegValue is a function in MYPROC)
m.glCanGoOn = .t.
m.gcNameSystem = GetRegValue("NameSystem")
m.gcVersion = GetRegValue("VersionSystem")
m.gcDefaultDataLocation = GetRegValue("DefautlDataLocation")
m.gnMinRAM = GetRegValue("MinRAM")
m.gnMinDiskSpace = GetRegValue("MinDiskSpace")
* make sure the default data set exists and is good
if !DataIsGood(m.gcDefaultDataLocation)
 m.glCanGoOn = .f.
endif
* check the hardware and OS
* (each of these functions is in MYPROC)
m.gnAvailRAM = GetRAM()
if m.gnAvailRAM < m.gnMinRAM
 m.glCanGoOn = .f.
endif
m.gnAvailDiskSpace = GetDiskSpace()
if m.gnAvailDiskSpace < m.gnMinDiskSpace
 m.glCanGoOn = .f.
endif
* initialize user login parms
m.gcNameUser = "ADMIN"
m.gcPassword = "ADMIN"
m.gcPermLevel = "00001"
m.glLoginWasGood = .t.
* get user login
do form LOGIN
if !m.glLoginWasGood
 m.glCanGoOn = .f.
endif
* define environment
oEnv.DoSets()
*
* set up event handler
*
* save old menu, run new one
if m.glCanGoOn
 *** push menu _MSYSMENU
 do IT.MPR
 read events
else
 * something bad happened so can't run app
 * (probably want to let the user know what)
endif
*
* clean up and close shop
*
* upon termination, restore menu 
***pop menu _MSYSMENU to master
set sysmenu to default
* return environment
oEnv.RestoreSets()
* clean out everything else
close all
clear menu
clear popup
clea program
clear window
clear
set talk &gcOldTalk
* from within VFP or from runtime
if version(2) = 0
 wait window nowait "See ya later, alligator"
 clear memory
 quit
else
 @2,0 say "See ya later, alligator"
 clear memory
 return
endif

* <EOF>
