********************************
*   eraser.prg
********************************
set blink off    && always
set talk off
set escape off
tm_total = 0     && total time variable
tm_down  = 0     && time down variable
*----- define stop window
DEFINE WINDOW stop FROM 3,62 TO 5,79 color w+/r
activate window stop
@ 0,1 say "We're History"
*----- define eraser (and brushes too, if desired)
DEFINE WINDOW eraser FROM 12,37 TO 12,42 none color n/r*
activate window eraser
@ 0,0 say 'eraser'
* define other windows for brushes here if desired
*----- prepare screen
activate screen

clea
for i = 1 to 100
 @rand()*wrows(), rand()*wcols() say chr(1) 
 @rand()*wrows(), rand()*wcols() say chr(2) 
endf

@ 0,62 clea to 2,79
@ 2,66 say 'Time'
@ 2,70 say tm_total pict '999.99'
*----- main inkey loop
DO WHILE .T.
   key_click = INKEY( 'HM' )
   IF key_click = 0
      LOOP
   ENDIF
   IF key_click = 27 or ;
      (key_click = 151 and mwindow('Stop'))
      *-- if Esc key or stop window clicked
      EXIT
   ENDIF
   IF key_click = 151 and mwindow('eraser')
      *-- if eraser clicked start time and drag
      tm_start = seconds()
      DO WHILE MDOWN()
         MOVE WINDOW eraser TO MROW(''),MCOL('')
         *-- erase
         @ MROW(''),MCOL('') say SPACE(6) COLOR SCHEME 1
         tm_down = seconds() - tm_start
         @ 2,66 SAY 'Time'
         @ 2,70 SAY tm_down + tm_total PICT '999.99'
      ENDDO
      tm_total = tm_total + tm_down
   ENDIF
   *-- add cases here if other drag windows are added
ENDDO
*---  clean up
RELEASE WINDOWS eraser, stop
set escape on
set talk on

